unit Unit57;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo4: TMemo;
    Memo5: TMemo;
    Memo6: TMemo;
    Memo7: TMemo;
    Memo8: TMemo;
    Memo9: TMemo;
    Memo10: TMemo;
    Memo11: TMemo;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button5: TButton;
    Edit8: TEdit;
    Memo12: TMemo;
    Memo13: TMemo;
    comburant: TLabel;
    carburant: TLabel;
    Memo14: TMemo;
    Memo15: TMemo;
    Memo16: TMemo;
    Memo17: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
     { Dclarations publiques }
     voyage : array[1..20,1..8]of double;
     mas,x,y,z,rx,ry,rz,t,xabs,yabs : double;
     ivoy : integer;
     motzag,motzad,motzdg,motzdd,motxag,motxad,motxrg,motxrd : double;
     vx,vy,vz,vrx,vry,vrz : double;
     mot1,mot2,mot3,mot4,mot5,mot6,mot7,mot8,trajectoire : textfile;
     eng1go,eng2go,eng3go,eng4go,eng5go,eng6go,eng7go,eng8go : textfile;
      test : integer;
      mascarb,mascomb : double;
      carte : textfile;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function SetCurrentDevice(CardAddress: integer): integer; stdcall; external 'K8055d.dll';
function OpenDevice(CardAddress: integer): integer; stdcall; external 'K8055d.dll';
function SearchDevices: integer; stdcall; external 'K8055d.dll';
function Version: integer; stdcall; external 'K8055d.dll';
procedure CloseDevice; stdcall; external 'K8055d.dll';
function ReadAnalogChannel(Channel: integer):integer; stdcall; external 'K8055d.dll';
procedure ReadAllAnalog(var Data1, Data2: integer); stdcall; external 'K8055d.dll';
procedure OutputAnalogChannel(Channel: integer; Data: integer); stdcall; external 'K8055d.dll';
procedure OutputAllAnalog(Data1: integer; Data2: integer); stdcall; external 'K8055d.dll';
procedure ClearAnalogChannel(Channel: integer); stdcall; external 'K8055d.dll';
procedure ClearAllAnalog; stdcall; external 'K8055d.dll';
procedure SetAnalogChannel(Channel: integer); stdcall; external 'K8055d.dll';
procedure SetAllAnalog; stdcall; external 'K8055d.dll';
procedure WriteAllDigital(Data: integer);stdcall;  external 'K8055d.dll';
procedure ClearDigitalChannel(Channel: integer); stdcall; external 'K8055d.dll';
procedure ClearAllDigital; stdcall; external 'K8055d.dll';
procedure SetDigitalChannel(Channel: integer); stdcall; external 'K8055d.dll';
procedure SetAllDigital; stdcall; external 'K8055d.dll';
function ReadDigitalChannel(Channel: integer): Boolean; stdcall; external 'K8055d.dll';
function ReadAllDigital: integer; stdcall; external 'K8055d.dll';
function ReadCounter(CounterNr: integer): integer; stdcall; external 'K8055d.dll';
procedure ResetCounter(CounterNr: integer); stdcall; external 'K8055d.dll';
procedure SetCounterDebounceTime(CounterNr, DebounceTime:integer); stdcall; external 'K8055d.dll';


procedure TForm1.Button1Click(Sender: TObject);
var
    motzagmoy,motzadmoy,motzdgmoy,motzddmoy : double;
    motzaganc,motzadanc,motzdganc,motzddanc : double;
    dt,tmax : double;
    vnx,vny : double;
    sx,sy,sz,rho : double;
    pos,pt : tpoint;
    tvrai,t0 : longint;
    t1,t2,t3,t4 : tpoint;
    surfhor : array[1..4] of tpoint;
    p,temp,consomdt,vejgaz,pourairliq,rza,vzanc,rzobj,vargas,witsel1,witsel2,witsel3,witsel4 : double;
    motxagdem,motxaddem,motxrgdem,motxrddem : double;
 {   mot1,mot2,mot3,mot4,mot5,mot6,mot7,mot8 : textfile;    }
    dx,epsx,epsz,epsteta,xint,zint,tint,epszmax,vmax,epsxmax,vmaxx : double;
    vmaxteta,epstetamax,corvit,gz,glat,vxanc,vyanc,ttop : double;
    epszanc,zreg,signe,xreg,zreganc : double;
    ok,ok1,ok2,ok3,stop : boolean;         {a nettoyer dans le programme}
    i,j,k,ijk,l : integer;
  {  q : tfield;     }
    nbrdt : integer;
    latitudedeg,latitudemin,latitudesec,longitudedeg,longitudemin,longitudesec : double;
    latitude,longitude,xabsanc,yabsanc,orbite,mas0 : double;
    h : integer;
    xabsref,yabsref,tref,dt1,dt2 : double;
    cardsonoff : boolean;

begin
  cardsonoff:=true;
{ SetCurrentDevice(0);
 h:=OpenDevice(0);
 SetCurrentDevice(1);
 h:=OpenDevice(1);
 SetCurrentDevice(2);
 h:=OpenDevice(2);
 SetCurrentDevice(3);
 h:=OpenDevice(3);    }
 mas0:=1.0*3663.0{10500.0};
 { mas:=3001.0;  }
 orbite:=0.0;
 latitudedeg:=47.33;
 latitudemin:=0;
 latitudesec:=0;
 longitudedeg:=-121.89;
 longitudemin:=0;
 longitudesec:=0;
  x:=0.0;
  y:=0.0;
  z:=0.0;
  rx:=0.0;
  ry:=0.0;
  rz:=0.0;
  t:=0.0;
  xabsref:=0.0;
  yabsref:=0.0;
  tref:=0.0;
   ivoy:=1;
   witsel1:=24.0{lbf spec}*4.536{lbf->N};{0.0*1.0*100}{1er test complet contre russie};
   witsel2:=0.0*100.0*0.1*-100;{resultat belgique 1 russie 0}
   witsel3:=24.0{lbf spec}*4.536{lbf->N};{0.0*150*0.1*-100}
   witsel4:=0.0{0.0*20.0*100};
     motzag:=30000-witsel1*0;
    motzad:=30000-witsel2*0;
    motzdg:=30000-witsel3*0;
    motzdd:=30000-witsel4*0;
    motxag:=0.0;
    motxad:=0.0;
    motxrg:=0*1000.0;
    motxrd:=0*1000.0;
      vx:=0.0;
  vy:=0.0;
  vz:=0.0;
  vrx:=0.0;
  vry:=0.0;
  vrz:=0.0;
  xabs:=x;
  yabs:=y;
  xabsanc:=xabs;
  yabsanc:=yabs;
  if false then
  begin
  voyage[1,1]:=0.0;
  voyage[1,2]:=0.0;
  voyage[1,3]:=10000.0;
  voyage[1,4]:=1.0;
  voyage[1,5]:=50.0;
  voyage[1,6]:=0.0;
  voyage[1,7]:=1000.0;
  voyage[1,8]:=1.0;
  voyage[2,1]:=7000000.0;
  voyage[2,2]:=0.0;
  voyage[2,3]:=400000.0;
  voyage[2,4]:=14000.0;
  voyage[2,5]:=500.0;
  voyage[2,6]:=0.0;
  voyage[2,7]:=10000.0;
  voyage[2,8]:=1.0;
  voyage[3,1]:=10300000.0;
  voyage[3,2]:=0.0;
  voyage[3,3]:=30000.0;
  voyage[3,4]:=100;
  voyage[3,5]:=500.0;
  voyage[3,6]:=0.0;
  voyage[3,7]:=50000.0;
  voyage[3,8]:=1.0;
  voyage[4,1]:=10300000.0;
  voyage[4,2]:=0.0;
  voyage[4,3]:=0.0;
  voyage[4,4]:=10.0;
  voyage[4,5]:=50.0;
  voyage[4,6]:=0.0;
  voyage[4,7]:=1.0;
  voyage[4,8]:=1.0;
  end;
  {essai de regularisation des avertissements}
  xreg:=0.0;
  motxagdem:=0.0;
  zreg:=0.0;
  motxaddem:=0.0;
  vzanc:=0.0;
  corvit:=0.0;
 motzaganc:=0.0;
 motzadanc:=0.0;
 motzdganc:=0.0;
 motzddanc:=0.0;


  dt:=0.02*10;{choix important calculateur}
  nbrdt:=0;


  sx:=4.0;
  sy:=10.0;
  sz:=10.0;
  xabs:=strtofloat(edit2.Text);
  yabs:=strtofloat(edit3.Text);
  z:=strtofloat(edit1.Text);
  vz:=strtofloat(edit6.Text)/3.6;
  mascomb:=strtofloat(edit7.Text);
  mascarb:=strtofloat(edit8.Text);
  mas:=mascomb+mascarb+mas0;
  vx:=sqrt(sqr((strtofloat(edit4.Text)+0.1)/3.6)-sqr(vz));
  rz:=strtofloat(edit5.Text)*3.1415926/180;
 { vy:=vx*sin(rz); vx est en local avancement
  vx:=vx*cos(rz);}
  rzobj:=0.0;
  canvas.pen.color:=clwhite;
  canvas.Brush.color:=clwhite;
  canvas.rectangle(0,0,1440,900);
  canvas.pen.color:=clblack;
  canvas.MoveTo(1,550);
  canvas.LineTo(1440,550);
  canvas.brush.color:=clblack;
  canvas.rectangle(0,550,1440,900);
    ok:=true;
    ok1:=true;
    ok2:=true;
    ok3:=true;
{interface important calculateur,language pascl vers c++    }
    assignfile(mot1,'mot1.txt');
    assignfile(mot2,'mot2.txt');
    assignfile(mot3,'mot3.txt');
    assignfile(mot4,'mot4.txt');
    assignfile(mot5,'mot5.txt');
    assignfile(mot6,'mot6.txt');
    assignfile(mot7,'mot7.txt');
    assignfile(mot8,'mot8.txt');
    assignfile(trajectoire,'trajectoire.txt');
    assignfile(carte,'carte.txt');
    if (test<>1) then
    begin
      rewrite(trajectoire);
    end;
    test:=0;
 {   rewrite(carte);                }

    {je debloque la sortie}vejgaz:=0.8;{source Air Liquide SA France}
    {jedebloque la sortie}vejgaz:=2.4*0.60;{source estimation scientifique personnelle 0.75 m/s :
    avant combustion 2.4 kg/dm3 apres combustion 2.4 kg/m3
    et sections 8*0.2*0.2*3.14->1.0}
    vejgaz:=1.0;{cfr spec 4 : c est la consommation estimee au mieux}
    pourairliq:=0.0;
{  t0:=getcurrenttime;
  t0:=1000*round(t0/1000+2.0);      }
  t0:=getcurrenttime;
{ writeln((frac(t0/1000)));   }
 while ((frac(t0/1000)>0.005) or (frac(t0/1000)<0.000))do
 begin
   t0:=getcurrenttime;
{   writeln((frac(t0/1000)));   }
 end;
  tmax:=60.0*30.0*6;

  xint:=0.0;
  zint:=0.0;
  tint:=0.0;
  epszmax:=100;
  epsxmax:=100;
  epstetamax:=3.1415926535;
  ttop:=0.0;
{repeat begin}
  while t<tmax do
  begin
    test:=0;
    t:=t+dt;
     cardsonoff:=not(cardsonoff);
    consomdt:=(motzag+motzad+motzdg+motzdd+motxag+motxad+motxrg+motxrd)/120000*
               (vejgaz*(1+(1/(15.91*1.00))))*dt; {cfr Anne-Lise et Xcor Aerospace}
    mascarb:=mascarb-consomdt*1/15.91;
    mascomb:=mascomb-consomdt*(1-1/15.91);
    mas:=mas0+mascarb+mascomb;
       motzagmoy:=motzag-motzaganc;
       motzadmoy:=motzad-motzadanc;
       motzdgmoy:=motzdg-motzdganc;
       motzddmoy:=motzdd-motzddanc;
    tvrai:=getcurrenttime;
    while ((tvrai-t0)/1000)<t do
    begin
      tvrai:=getcurrenttime;
      for ijk:=1 to 1000000 do l:=ijk;
    end;
    ijk:=l;
    rewrite(mot1);
    writeln(mot1,(motzag/30000):10:3);
    if cardsonoff  then
    begin
      SetCurrentDevice(0);
      h:=OpenDevice(0);
      OutputAnalogChannel(1,round(motzag/30000*255+0));
      {SetCurrentDevice(0);
 h:=OpenDevice(0); }
      OutputAnalogChannel(2,round(motxrg/30000*255+0));
    end;
    closefile(mot1);
    rewrite(mot2);
    writeln(mot2,(motzad/30000):10:3);
    closefile(mot2);
    rewrite(mot3);
    writeln(mot3,(motzdg/30000):10:3);
    closefile(mot3);
    rewrite(mot4);
    writeln(mot4,(motzdd/30000):10:3);
    closefile(mot4);
    rewrite(mot5);
    writeln(mot5,(motxag/30000):10:3);
    closefile(mot5);
    rewrite(mot6);
    writeln(mot6,(motxad/30000):10:3);
    if not(cardsonoff) then
    begin
    SetCurrentDevice(1);
 h:=OpenDevice(1);
   { OutputAnalogChannel(3,round(motxag/30000*255+0));ordi HP avec 2 cartes 100% ok}
  {   SetCurrentDevice(1);
 h:=OpenDevice(1);       }
    OutputAnalogChannel(4,round(motxad/30000*255+0));
    end;

{     SetCurrentDevice(2);
 h:=OpenDevice(2);
    OutputAnalogChannel(5,round(motxag/30000*255+0));              }
   {  closedevice;   }
{     SetCurrentDevice(2);
 h:=OpenDevice(2);
    OutputAnalogChannel(6,round(motxad/30000*255+0));      }
   {  closedevice;     }
    closefile(mot6);
    rewrite(mot7);
    writeln(mot7,(motxrg/30000):10:3);
{     SetCurrentDevice(3);
 h:=OpenDevice(3);
    OutputAnalogChannel(7,round(motxrg/30000*255+0));      }
    { closedevice;  }
{     SetCurrentDevice(3);
 h:=OpenDevice(3);
    OutputAnalogChannel(8,round(motxrd/30000*255+0));      }
 {    closedevice;    }
    closefile(mot7);
    rewrite(mot8);
    writeln(mot8,(motxrd/30000):10:3);
    closefile(mot8);
    nbrdt:=nbrdt+1;
    if ((nbrdt=300) and (test<>1))then
    begin
      latitude:=latitudedeg+latitudemin/60+latitudesec/3600;
      longitude:=longitudedeg+longitudemin/60+longitudesec/3600;
      latitude:=latitude+(xabs-xabsanc)/6378000.0*180/3.1415926535;
      longitude:=longitude+(yabs-yabsanc)/6378000.0*180/3.1415926535/cos(latitude*3.1415926535/180);
      rewrite(carte);
      writeln(carte,latitude,' ',longitude,' ',sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6);
      closefile(carte);
      latitudedeg:=int(latitude);
      latitudemin:=int((latitude-latitudedeg)*60);
      latitudesec:=int((latitude-latitudedeg-latitudemin/60)*3600);
      longitudedeg:=int(longitude);
      longitudemin:=int((longitude-longitudedeg)*60);
      longitudesec:=int((longitude-longitudedeg-longitudemin/60)*3600);
      writeln(trajectoire,'lat(deg,min,sec) : ',
      latitudedeg:3:3,',',latitudemin:2:2,',',latitudesec:7:3,
      'long(deg,min,sec) :',
      longitudedeg:3:3,',',longitudemin:2:2,',',longitudesec:7:3,
      ' z(m)= ',z);
      writeln(trajectoire,'v tot(km/h) = ',sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6,
                          'vz (km/h) = ',vz*3.6,' t(sec)= ',t);
{      writeln(trajectoire,'F vert z(N) = ',rho*sqr(vz)/2*sz*1.3,
                          'F avanc (N) = ',rho*sqr(vx)/2*sx*1.5);  }
      nbrdt:=0;
      xabsanc:=xabs;
      yabsanc:=yabs;
    end;

    vmax:=voyage[ivoy,5]/3.6;
    vmaxx:=voyage[ivoy,4]/3.6;
    vmaxteta:=3.1415926535/300*1/1{}/1{accel g lat};
    canvas.Brush.color:=clgreen;
    canvas.rectangle(250,100,290,120);
    if ((pt.x>250)and(pt.x<290)and(pt.y>100)and(pt.y<120)) then
    begin
      tmax:=0.0;
    end;
    if z<10000 then temp:=293.16*(1*((10000-z)/10000)+(z/10000)*(1/sqrt(sqrt(2))))
               else temp:=293.16/sqrt(sqrt(2));
    if z<10000 then p:=1.013e5*(((10000-z)/10000)*1+(z/10000)*0.25)
               else
         if z<20000 then p:=1.013e5*(((20000-z)/10000)*0.25+((z-10000)/10000)*0.1)
                    else p:=0.1*1.013e5*exp(-9.81*(z-20000)/287*temp);
    rho:=p/(287*temp);
    getcursorpos(pt);
    canvas.brush.color:=clgreen;
    canvas.Rectangle(70,600,170,800);
    canvas.rectangle(240,600,340,800);
    canvas.rectangle(410,600,510,800);
    canvas.rectangle(580,600,680,800);
    canvas.rectangle(750,600,850,800);
    canvas.rectangle(920,600,1020,800);
    canvas.rectangle(1090,600,1190,800);
    canvas.rectangle(1260,600,1360,800);
    canvas.Brush.color:=clblue;
 {:::}   canvas.Rectangle(300,530,350,580);
    motzaganc:=motzag;
    motzadanc:=motzad;
    motzdganc:=motzdg;
    motzddanc:=motzdd;
    epsz:=voyage[ivoy,3]-z;
  { suspendu definitivement de reglage
    if (abs(epsz)<vmax*60)and ok1 then begin
      vmax:=vmax/12;
      ok1:=true;
                              end;       }
    if (epsz>epszmax)  then epsz:=epszmax;
    if (epsz<-1*epszmax)  then epsz:=-1*epszmax;
    if abs(epsz)>1e-5 then signe:=epsz/abs(epsz);
    zint:=zint+(60/5/5)*epsz;
    if (zint>epszmax*300)  then zint:=epszmax*300;
    if (zint<-1*epszmax*300*0)  then zint:=-1*epszmax*300*0;

 if vmax<13.0 then
                begin
         zreganc:=zreg;
         if vz>0 then zreg:=zreganc-1;
         if vz<0 then zreg:=zreganc+1;
         if epsz>0 then zreg:=zreg+1;
         if epsz<0 then zreg:=zreg-1;
         if vz<-5.0 then zreg:=zreganc+30;
         if vz>5.0 then zreg:=zreganc-30;
         zint:=0.0;
                end
             else
    if ((epsz>0)and(vz>vmax)or((epsz<0)and(vz<-vmax))) then
    begin
      zint:=zint-120/5/5*epsz;
      zreg:=zint;
    end
                      else zreg:=zint;
    epsx:=sqrt(sqr(voyage[ivoy,1]-xabs)+sqr(voyage[ivoy,2]-yabs));
   { suspendu
     if (abs(epsx)<vmaxx*60*1)and ok2 then begin
      vmaxx:=vmaxx/12;
      ok2:=true;
                              end;                    }
    if (epsx>epsxmax)  then epsx:=epsxmax;
    if (epsx<-1*epsxmax)  then epsx:=-1*epsxmax;
    xint:=xint+(60/5/5)*epsx;
    if (xint>epsxmax*300)  then xint:=epsxmax*300;
    if (xint<-1*epsxmax*300)  then xint:=-1*epsxmax*300;
    if vmaxx<13.0 then
                 begin
  {      zreg:=zint*25/3+18000/5/5*25/3*epsz-1800/5/5*25/3*(epsz-epszanc);}
         xreg:=xreg;
         if vx>0 then xreg:=xreg-1;
         if vx<0 then xreg:=xreg+1;
         if vx>5.0 then xreg:=xreg-30;
         if vx<-5.0 then xreg:=xreg+30;
         if epsx>0 then xreg:=xreg+1;
         if epsx<0 then xreg:=xreg-1;
         xint:=0.0;
                end
             else
    if ((epsx>0)and(vx>vmaxx)or((epsx<0)and(vx<-vmaxx))) then
    begin
      xint:=xint-120/5/5*epsx;
      xreg:=xint;
    end
                      else xreg:=xint;

    motzag:=zreg;
    if frac(t)<0.5 then motzag:=motzag+1000/10
                   else motzag:=motzag-1000/10;
    motzad:=motzag-witsel1*1;
    motzdg:=motzag+witsel2*0;
    motzdd:=motzag-witsel3*1;
    if xreg>0 then
    begin
      motxagdem:=xreg;
      motxaddem:=xreg;
    end;
    if motxagdem>28000 then motxagdem:=28000;
    if motxaddem>28000 then motxaddem:=28000;
    if xreg<0 then
    begin
      motxrgdem:=-1.0*xreg;
      motxrddem:=-1.0*xreg;
    end;
    epsteta:=+1.0*(rzobj-rz);
    if (epsteta>3.14159265355)  then epsteta:=epsteta-2*3.1415926535;
    if (epsteta<-3.14159265355)  then epsteta:=epsteta+2*3.1415926535;
      if (abs(epsteta)<1/180*3.1415926535)and ok3 then begin
      vmaxteta:=vmaxteta/12;
      ok3:=true;
                              end;
    if (epsteta>epstetamax)  then epsteta:=epstetamax;
    if (epsteta<-1*epstetamax)  then epsteta:=-1*epstetamax;
    tint:=tint+((1-exp(dt/-0.14))*epsteta);
    if (tint>epstetamax/300)  then tint:=epstetamax/300;
    if (tint<-1*epstetamax/300)  then tint:=-1*epstetamax/300;
    dx:=-105000*epsteta+102000*tint;
    if dx>300/6 then dx:=300/6;
    if dx<-300/6 then dx:=-300/6;
    if motzag<0 then  motzag:=0.0;
    if motzag>30000 then  motzag:=30000.0;
    if motzad<0 then  motzad:=0.0;
    if motzad>30000 then  motzad:=30000.0;
    if motzdg<0 then  motzdg:=0.0;
    if motzdg>30000 then  motzdg:=30000.0;
    if motzdd<0 then  motzdd:=0.0;
    if motzdd>30000 then  motzdd:=30000.0;
    if motxagdem>30000 then  motxagdem:=30000.0;
    {!!!!!optionnel!!!!!}
    if (voyage[ivoy,8]<>4) then
    begin
       dx:=0.0;
       if (epsteta*180/3.1416>2) then dx:=-5.0;
       if(epsteta*180/3.1416<-2) then dx:=5.0;
    end;

    if dx<0.0 then motxag:= motxagdem+abs(dx)
              else motxag:=motxagdem;
    if (vrz)>vmaxteta then motxag:=motxagdem-30;
    if motxag<0 then  motxag:=0.0;
    if motxad>30000 then  motxad:=30000.0;
    if dx>0.0 then motxad:= motxaddem+abs(dx)
               else motxad:=motxaddem;
    if (vrz)<-vmaxteta then motxad:=motxaddem-30;
    if motxad<0 then  motxad:=0.0;
    motxrg:=motxrgdem;
    motxrd:=motxrddem;
    if motxrg>30000 then  motxrg:=30000.0;
    if motxrg<0 then  motxrg:=0.0;
    if motxrd>30000 then  motxrd:=30000.0;
    if motxrd<0 then  motxrd:=0.0;
     if (mascomb<0) or(mascarb<0) then begin
       motzag:=0*30000-0*1000-0*30000;
       motzad:=0*30000;
       motzdg:=0*30000-0*1000;
       motzdd:=0*30000-0*30000;
       motxag:=0.0;
       motxad:=0.0;
       motxrg:=0*1000.0;
       motxrd:=0*1000.0;
                     end;
 if z<-0.0001 then
    begin
              motzag:=0.0;
              motzad:=0.0;
              motzdg:=0.0;
              motzdd:=0.0;
              motxag:=0.0;
              motxad:=0.0;
              motxrg:=0.0;
              motxrd:=0.0;
    end;
{pour l instant supprime
       if (voyage[ivoy,8]=3) then
       begin
         motxag:=0.0;
         motxad:=0.0;
         motxrg:=0*1000.0;
         motxrd:=0*1000.0;
       end;             }

 {   if ((pt.x>300)and(pt.x<350)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag+30000*0.001/4;
      motzad:=motzad+30000*0.001/4;
      motzdg:=motzdg+30000*0.001/4;
      motzdd:=motzdd+30000*0.001/4;
    end;   }
    canvas.rectangle(860,560,910,610);
   { if ((pt.x>860)and(pt.x<910)and(pt.y>560)and(pt.y<610)) then
    begin
      motxag:=motxag+30000*0.001;
      motxad:=motxad+30000*0.001;
    end;}
    canvas.rectangle(1200,560,1250,610);
  {  if ((pt.x>1200)and(pt.x<1250)and(pt.y>560)and(pt.y<610)) then
    begin
      motxrg:=motxrg+30000*0.001;
      motxrd:=motxrd+30000*0.001;
    end;}
    canvas.brush.color:=rgb(255,128,0);
{:::::}    canvas.rectangle(400,530,450,580);
   { if ((t>0.1)and(pt.x>400)and(pt.x<450)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/4;
      motzad:=motzad-30000*0.001/4;
      motzdg:=motzdg-30000*0.001/4;
      motzdd:=motzdd-30000*0.001/4;
    end;}
    canvas.rectangle(860,650,910,700);
   { if ((pt.x>860)and(pt.x<910)and(pt.y>650)and(pt.y<700)) then
    begin
      motxag:=motxag-30000*0.001;
      motxad:=motxad-30000*0.001;
    end;}
    canvas.Rectangle(1200,650,1250,700);
   { if ((pt.x>1200)and(pt.x<1250)and(pt.y>650)and(pt.y<700)) then
    begin
      motxrg:=motxrg-30000*0.001;
      motxrd:=motxrd-30000*0.001;
    end; }
{:::}    canvas.brush.color:=clgreen;
    canvas.rectangle(350,530,400,580);
 {   if ((pt.x>350)and(pt.x<400)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/5/4;
      motzad:=motzad-30000*0.001/5/4;
      motzdg:=motzdg-30000*0.001/5/4;
      motzdd:=motzdd-30000*0.001/5/4;
    end; }
    canvas.brush.color:=clblue;
{    canvas.rectangle(80,810,110,840);
    canvas.rectangle(250,810,280,840);
    canvas.rectangle(420,810,450,840);
    canvas.rectangle(590,810,620,840);   }
    canvas.rectangle(760,810,790,840);
   { if ((pt.x>760)and(pt.x<790)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxag+30000*0.0001/5;
    end;
    if motxag>motxad+0.01*30000 then motxag:=motxad+0.01*30000; }
  {  canvas.rectangle(930,810,960,840);
    canvas.rectangle(1100,810,1130,840);
    canvas.rectangle(1270,810,1300,840);  }
    canvas.brush.color:=rgb(255,128,0);
 {   canvas.rectangle(130,810,160,840);
    canvas.rectangle(300,810,330,840);
    canvas.rectangle(470,810,500,840);
    canvas.rectangle(640,810,670,840);    }
    canvas.rectangle(810,810,840,840);
   { if ((pt.x>810)and(pt.x<840)and(pt.y>810)and(pt.y<840)) then
    begin
      motxad:=motxad+30000*0.0001/5;
    end;
    if motxag<motxad-0.01*30000 then motxad:=motxag+0.01*30000;   }
  {  canvas.rectangle(980,810,1010,840);
    canvas.rectangle(1150,810,1180,840);
    canvas.rectangle(1320,810,1350,840);     }
    canvas.Brush.color:=clgreen;
    canvas.rectangle(790,810,810,840);
   { if ((pt.x>790)and(pt.x<810)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxad;
    end; }

    canvas.Brush.color:=clred;
    canvas.Rectangle(70,round(800-200*(motzag/30000)),170,800);
    canvas.rectangle(240,round(800-200*(motzdg/30000)),340,800);
    canvas.rectangle(410,round(800-200*(motzad/30000)),510,800);
    canvas.rectangle(580,round(800-200*(motzdd/30000)),680,800);
    if abs(motxrg-motxrd)>1 then canvas.Brush.color:=rgb(255,128,0);
    canvas.rectangle(1090,round(800-200*(motxrg/30000)),1190,800);
    canvas.rectangle(1260,round(800-200*(motxrd/30000)),1360,800);
    canvas.Brush.color:=clred;
    if abs(motxag-motxad)>1 then canvas.Brush.color:=rgb(255,128,0);
    canvas.rectangle(750,round(800-200*(motxag/30000)),850,800);
    canvas.rectangle(920,round(800-200*(motxad/30000)),1020,800);
    canvas.Brush.Color:=rgb(255,128,0);
    if (abs(motxag-motxad)>1)and(motxag<1500) then
          canvas.rectangle(750,round(800-200*10*(motxag/30000)),850,800);
    if (abs(motxag-motxad)>1)and(motxad<1500) then
        canvas.rectangle(920,round(800-200*10*(motxad/30000)),1020,800);
   {11&&& if (t>0.1) then begin
    canvas.Rectangle(120,round(700-200/2*500*(motzagmoy/30000)),170,700);
    canvas.rectangle(290,round(700-200/2*500*(motzadmoy/30000)),340,700);
    canvas.rectangle(460,round(700-200/2*500*(motzdgmoy/30000)),510,700);
    canvas.rectangle(630,round(700-200/2*500*(motzddmoy/30000)),680,700);
                    end;     }
   { if motxrd<0 then  motxrd:=0.0;
       if dx>0.0 then motxad:= motxad+dx;  }

{parachute de 100 m2 : 10 m x 10 m}
    canvas.Brush.Color:=clyellow;
    canvas.rectangle(500,100,530,130);
    if ((pt.x>500)and(pt.x<530)and(pt.y>100)and(pt.y<130)) then
    begin
      sz:=100.0;
    end;
    {passage au point suivant du voyage}
    canvas.Brush.Color:=clred;
    canvas.rectangle(400,100,430,130);
    if ((ttop<t) and stop and(pt.x>400)and(pt.x<430)and(pt.y>100)and(pt.y<130)) then
    begin
      ivoy:=ivoy+1;
      stop:=false;
      ttop:=t+5.0;
    end
    else stop:=true;
  {erreur du compilateur amricain : il ne prend pas en compte ces lignes
    if orbite=1.0  then
    begin
      motxag:=0.0;
      motxad:=0.0;
      motxrg:=0.0;
      motxrd:=0.0;
      motzag:=0.0;
      motzad:=0.0;
      motzdg:=0.0;
      motzdd:=0.0;
    end;                                                       }

    vargas:=(sqr(vx)+sqr(vy))/((6500000+z)*9.81);
    vx:=vx+(motxag+motxad-motxrg-motxrd-rho*vx*abs(vx)*1.3*sx/2)*dt/mas;
    vy:=vy+(0.0-rho*vy*abs(vy)*2.0*sy/2)*dt/mas;
    vz:=vz+(motzag+motzad+motzdg+motzdd-mas*9.81*(1-vargas)*(cos(rx)*cos(ry))-rho*vz*abs(vz)*1.5*sz)*dt/mas;
    vrx:=vrx+(motzad*1.0+motzag*(-1)+motzdd*1.0+motzdg*(-1)-mas*9.81*(1-vargas)*1.0*sin(rx+0*3.14/2))*dt/(mas*0.7*0.7);
    vry:=vry+(motzag*2.0+motzad*2.0-motzdg*2.0-motzdd*2.0
              -motxag*0.0-motxad*0.0+motxrg*0.0+motxrd*0.0-mas*9.81*(1-vargas)*2.0*sin(ry+0*3.14/2)
              +0.0*2.0*2.0*0.5*4.0*rho*vx*cos(ry)*abs(vx*cos(ry))/2)*dt/(mas*1.5*1.5);
    vrz:=vrz+(motxag*(0.5)-motxad*0.5-motxrg*0.5+motxrd*0.5)*dt/(mas*1.0*1.0);
    gz:=9.81*(1-vargas)*1.0+(vz-vzanc)/dt;
    glat:=sqr(rz)*(2.5)*1.0+sqrt(sqr((vx-vxanc)/dt)+sqr((vy-vyanc)/dt));
    vnx:=vx*cos(vrz*dt)-vy*sin(vrz*dt);
    vny:=vx*sin(vrz*dt)+vy*cos(vrz*dt);
    vx:=vnx;
    vy:=vny;
    x:=x+vx*dt;
    y:=y+vy*dt;
  {  z:=z+vz*dt; }
    rx:=rx+vrx*dt;
    ry:=ry+vry*dt;
    rz:=rz+vrz*dt;
    xabs:=xabs+vx*cos(rz)*dt-vy*sin(rz)*dt;
    yabs:=yabs+vx*sin(rz)*dt+vy*cos(rz)*dt;
    if xabs>36000000 then  xabs:=0.0;
    if yabs>36000000 then  yabs:=0.0;
    if xabs<-36000000 then  xabs:=0.0;
    if yabs<-36000000 then  yabs:=0.0;
    if vy>0 then corvit:=(-17/3)/180*3.1415926535;
    if vy<0 then corvit:=(17/3)/180*3.1415926535;

    if z<0.0  then
    begin
      if sqrt(sqr(xabs)+sqr(yabs))<10000.0 then begin
        vz:=0.0;
        z:=0.0;
                    end
            else
            if z>-2.0 then
            begin
              vz:=vzanc+(-mas*9.81-z*5.0*2.0*1000*9.81
                                -1000*vzanc*abs(vzanc)/2*5.0*2.0*2.0)/mas*dt
            end
                      else
            begin
              closefile(trajectoire);
              closefile(carte);
              vz:=vzanc+(-mas*9.81-(-2.0)*5.0*2.0*1000*9.81
                                -1000*vzanc*abs(vzanc)/2*5.0*2.0*2.0)/mas*dt;
            end;
      vx:=0.0;
      vy:=0.0;
      vrz:=0.0;
    end;
    z:=z+vz*dt;
    {versio 8}
    vzanc:=vz;
    vxanc:=vx;
    vyanc:=vy;
    canvas.pen.color:=clblue;
    canvas.brush.color:=clwhite;
    canvas.rectangle(720,100,1020,400);
    canvas.Brush.color:=clblue;
    canvas.ellipse(720,100,1020,400);
    canvas.Brush.color:=clblack;
    t1.x:=720;
    t1.y:=400;
    t2.x:=720+round(0);
    t2.y:=250+round(150*sin(ry)+150*sin(rx));
    t3.x:=1020+round(0);
    t3.y:=250+round(150*sin(ry)-150*sin(rx));
    t4.x:=1020;
    t4.y:=400;
    surfhor[1]:=t1;
    surfhor[2]:=t2;
    surfhor[3]:=t3;
    surfhor[4]:=t4;
    canvas.polygon(surfhor);
    canvas.Brush.color:=clwhite;
    canvas.rectangle(1050,250,1350,350);
    canvas.brush.color:=clblue;
    while rz>2*3.1415626535 do rz:=rz-2*3.1415926535;
    while rz<0*-3.1415926535 do rz:=rz+2*3.1415926535;
        if rz<3.1415926535 then rza:=rz
            else rza:= rz -3.1415926*2;
    canvas.rectangle(1050,250,1200+round(150*rza/3.1415926535),350);
    memo1.lines.clear;
    memo1.lines.add('Hauteur(m) = '+floattostr(z));
    memo2.lines.clear;
    memo2.lines.add('Avancement Nord(m) = '+floattostr(xabs));
    memo3.lines.clear;
    memo3.lines.add('Avancement Est(m) = '+floattostr(yabs));
    memo4.lines.clear;
   { memo4.lines.add('vitesse totale (km/h) = '+floattostr(sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6));   }
    memo4.Lines.Add('vitesse x local (km/h) = '+floattostr(vx*3.6));
    memo17.Lines.Clear;
    memo17.Lines.Add('vitesse y local (km/h) = '+floattostr(vy*3.6));
    memo5.lines.clear;
    memo5.lines.add('compas (degre)() = '+floattostr(rz*180/3.1415926535));
    memo6.lines.clear;
    memo6.lines.add('vitesse vertiale (km/h) = '+floattostr(vz*3.6));
    memo7.lines.clear;
    if abs(-xabs+voyage[ivoy,1])>1.0 then begin
       rzobj:=arctan((-yabs+voyage[ivoy,2])/(-xabs+voyage[ivoy,1]));
       if ((-xabs+voyage[ivoy,1])<0.0) then rzobj:=rzobj-3.1415926535;
                        end
                   else if abs(-yabs+voyage[ivoy,2])<1.0 then rzobj:= 0.0
                                         else if (-yabs+voyage[ivoy,2]<0) then rzobj:=-3.1415926535/2
                                                          else rzobj:=3.1415926535/2;
{essai de convergence }
   { corvit:=0.0;   extinction supprimee }
    rzobj:=rzobj+corvit;
    while rzobj>2*3.1415626535 do rzobj:=rzobj-2*3.1415926535;
    while rzobj<0*-3.1415926535 do rzobj:=rzobj+2*3.1415926535;
    memo7.lines.add('objectif(degre)() = '+floattostr(rzobj*180/3.1415926535));
    memo8.Lines.Clear;
    memo8.Lines.Add(floattostr(mas)+'kg');
    memo12.Lines.Clear;
    memo12.Lines.Add(floattostr(mascomb)+'kg');
    memo13.Lines.Clear;
    memo13.Lines.Add(floattostr(mascarb)+'kg');
    canvas.Brush.Color:=clblue;
    canvas.rectangle(600,100,630,130);
    if ((ttop<t) and stop and(pt.x>600)and(pt.x<630)and(pt.y>100)and(pt.y<130)) then
    begin
      tref:=t;
      xabsref:=xabs;
      yabsref:=yabs;
      stop:=false;
      ttop:=t+5.0;
    end
    else stop:=true;
    memo14.Lines.Clear;
    memo14.Lines.Add(floattostr(sqrt(sqr(xabsref-xabs)+sqr(yabsref-yabs))/1000)+' km');
    memo15.Lines.Clear;
    if (yabs-yabsref>1e-8) then
        memo15.Lines.Add(floattostr(90.0-180/3.1415926535*arctan((xabs-xabsref)/(yabs-yabsref)))+' degres');
    if (yabs-yabsref<-1e-8) then
        memo15.Lines.Add(floattostr(270.0-180/3.1415926535*arctan((xabs-xabsref)/(yabs-yabsref)))+' degres');
    if (abs(yabs-yabsref)<1.2e-8) then
       if ((xabs-xabsref)>0) then
         begin
           memo15.Lines.Clear;
           memo15.Lines.Add(floattostr(0)+' degres')
         end
                              else
         begin
           memo15.Lines.Clear;
           memo15.Lines.Add(floattostr(180)+' degres');
         end;

    memo16.Lines.Clear;
    dt1:=t-tref;
    dt2:=dt1;
    dt1:=int(dt1/60);
    dt2:=dt2-60*dt1;
    memo16.Lines.Add(floattostr(dt1)+'min '+floattostr(dt2)+'sec ');
    memo10.Lines.Clear;
    memo10.Lines.Add(floattostr(gz)+'m/s2');
    memo9.Lines.Clear;
{    if abs(glat)<2*9.81 then memo9.Lines.Add('inferieur a 2 g')
      else if abs(glat)<5*9.81 then memo9.Lines.Add('inferieur a 5 g')
                 else }memo9.Lines.Add(floattostr(glat)+'m/s2');
    memo11.Lines.Clear;
    memo11.Lines.Add(inttostr(ivoy));
    canvas.brush.color:=clred;
     if (voyage[ivoy,8]=4.0) then
         if ((abs((rz-rzobj)*180/3.1415926535) < 2.0)or
         ((rz<1/180*3.1415926535)and(rzobj>359/180*3.1415926535))
         or  ((rzobj<1/180*3.1415926535)and(rz>359/180*3.1415926535)))
          then ivoy:=ivoy+1;
    if (voyage[ivoy,8]=1.0) then
         if sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2])+
            sqr(z-voyage[ivoy,3])) < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=2.0) then
         if sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2]))
              < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=3.0) then
         if sqrt(sqr(z-voyage[ivoy,3])) < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=5.0) then
         if (sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2]))
              < voyage[ivoy,7])and(abs(vx)<vmaxx) then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=6.0) then orbite:=1.0;



    if ((vzanc*3.6<-10.0)and(z<0.3))then canvas.Rectangle(1,1,1024,400);
   { memo12.Lines.Add(floattostr(voyage[ivoy,3])+'!'+floattostr(voyage[ivoy,5]));   }
  end;
    {interface important calculateur,language pascl vers c++  }
 {   closefile(mot1);
    closefile(mot2);
    closefile(mot3);
    closefile(mot4);
    closefile(mot5);
    closefile(mot6);
    closefile(mot7);
    closefile(mot8);    }
{  writeln('t(sec) =',t:5:3,'x(m) =',x:10:3,'y(m) = ',y:10:3,'z(m) = ',z:10:3); }
 { end;
  until false;}
  {closedevice;}
  closefile(trajectoire);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   motzagmoy,motzadmoy,motzdgmoy,motzddmoy : double;
    motzaganc,motzadanc,motzdganc,motzddanc : double;
    dt,tmax : double;
    vnx,vny : double;
    sx,sy,sz,rho : double;
    pos,pt : tpoint;
    tvrai,t0 : longint;
    t1,t2,t3,t4 : tpoint;
    surfhor : array[1..4] of tpoint;
    p,temp,consomdt,vejgaz,pourairliq,rza,vzanc,rzobj,varg : double;
{choix var locale    mot1,mot2,mot3,mot4,mot5,mot6,mot7,mot8 : textfile;     }
    dx,epsx,epsz,epsteta,xint,zint,tint,epszmax,vmax,epsxmax,vmaxx : double;
    vmaxteta,epstetamax,corvit,gz,glat,vxanc,vyanc,ttop : double;
    ok,ok1,ok2,ok3,stop : boolean;
    i,j,k,ijk,l : integer;
 {   q : tfield;   }
begin
  dt:=0.02*10;{choix important calculateur}
  sx:=4.0;
  sy:=10.0;
  sz:=10.0;
  {selon le film   }
  canvas.pen.color:=clwhite;
  canvas.Brush.color:=clwhite;
  canvas.rectangle(0,0,1440,900);
  canvas.pen.color:=clyellow;
  canvas.MoveTo(1,550);
  canvas.LineTo(1440,550);
  canvas.brush.color:=clblue;
  canvas.rectangle(0,550,1440,900);





    ok:=true;
    ok1:=true;
    ok2:=true;
    ok3:=true;
    vejgaz:=0.8;
    pourairliq:=0.0;
  t0:=getcurrenttime;
  tmax:=60.0*30.0*6;
  xint:=0.0;    {?}
  zint:=0.0;     {?}
  tint:=0.0;      {?}
  epszmax:=100;
  epsxmax:=100;
  epstetamax:=3.1415926535;
  ttop:=0.0;
   {essai de regularisation des avertissements}
  vzanc:=0.0;
  rzobj:=0.0;
  corvit:=0.0;
 motzaganc:=0.0;
 motzadanc:=0.0;
 motzdganc:=0.0;
 motzddanc:=0.0;

  {interface important calculateur,language pascl vers c++
    assignfile(mot1,'mot1.txt');
    assignfile(mot2,'mot2.txt');
    assignfile(mot3,'mot3.txt');
    assignfile(mot4,'mot4.txt');
    assignfile(mot5,'mot5.txt');
    assignfile(mot6,'mot6.txt');
    assignfile(mot7,'mot7.txt');
    assignfile(mot8,'mot8.txt'); }
    {bug de passage contr}t:=0.0;
repeat begin
 { while t<tmax do
  begin }
    t:=t+dt;
    consomdt:=(motzag+motzad+motzdg+motzdd+motxag+motxad+motxrg+motxrd)/120000*
               (vejgaz*(1+(1/20)))*dt;
    mas:=mas-consomdt*(1+pourairliq);
       motzagmoy:=motzag-motzaganc;
       motzadmoy:=motzad-motzadanc;
       motzdgmoy:=motzdg-motzdganc;
       motzddmoy:=motzdd-motzddanc;
    tvrai:=getcurrenttime;
    while ((tvrai-t0)/1000)<t do
       begin
      tvrai:=getcurrenttime;
      for ijk:=1 to 1000000 do l:=ijk;
    end;
    ijk:=l;
    rewrite(mot1);
    writeln(mot1,(motzag/30000):10:3);
    closefile(mot1);
    rewrite(mot2);
    writeln(mot2,(motzad/30000):10:3);
    closefile(mot2);
    rewrite(mot3);
    writeln(mot3,(motzdg/30000):10:3);
    closefile(mot3);
    rewrite(mot4);
    writeln(mot4,(motzdd/30000):10:3);
    closefile(mot4);
    rewrite(mot5);
    writeln(mot5,(motxag/30000):10:3);
    closefile(mot5);
    rewrite(mot6);
    writeln(mot6,(motxad/30000):10:3);
    closefile(mot6);
    rewrite(mot7);
    writeln(mot7,(motxrg/30000):10:3);
    closefile(mot7);
    rewrite(mot8);
    writeln(mot8,(motxrd/30000):10:3);
    closefile(mot8);
    vmax:=voyage[ivoy,5]/3.6;
    vmaxx:=voyage[ivoy,4]/3.6;
    vmaxteta:=3.1415926535/300*1/1{}/1{accel g lat};
    canvas.Brush.color:=clgreen;
    canvas.rectangle(250,100,290,120);
    if ((pt.x>250)and(pt.x<290)and(pt.y>100)and(pt.y<120)) then
    begin
      tmax:=0.0;
    end;
    if z<10000 then temp:=293.16*(1*((10000-z)/10000)+(z/10000)*(1/sqrt(sqrt(2))))
               else temp:=293.16/sqrt(sqrt(2));
    if z<10000 then p:=1.013e5*(((10000-z)/10000)*1+(z/10000)*0.25)
               else
         if z<20000 then p:=1.013e5*(((20000-z)/10000)*0.25+((z-10000)/10000)*0.1)
                    else p:=0e5;
    rho:=p/(287*temp);
 {   if t>0 then motzag:=30000-0*1000-0*30000;
    if t>0 then motzad:=30000;
    if t>0 then motzdg:=30000-0*1000;
    if t>0 then motzdd:=30000-0*30000;
    if ((t>10) and (t<45)) then motxag:=1.0*30000
             else motxag:=0.0;
    if ((t>10) and (t<45)) then motxad:=1.0*30000
            else motxad:=0.0;
    if t>45 then motxrg:=30000
            else motxrg:=0*1000.0;
    if t>45 then motxrd:=30000
            else motxrd:=0*1000.0;    }
    getcursorpos(pt);
    canvas.brush.color:=clgreen;
    canvas.Rectangle(70,600,170,800);
    canvas.rectangle(240,600,340,800);
    canvas.rectangle(410,600,510,800);
    canvas.rectangle(580,600,680,800);
    canvas.rectangle(750,600,850,800);
    canvas.rectangle(920,600,1020,800);
    canvas.rectangle(1090,600,1190,800);
    canvas.rectangle(1260,600,1360,800);
    canvas.Brush.color:=clblue;
 {:::}   canvas.Rectangle(300,530,350,580);
    motzaganc:=motzag;
    motzadanc:=motzad;
    motzdganc:=motzdg;
    motzddanc:=motzdd;
    epsz:=voyage[ivoy,3]-z;
    if (abs(epsz)<vmax*60)and ok1 then begin
      vmax:=vmax/12*3;
      ok1:=true;
                              end;
    if (epsz>epszmax)  then epsz:=epszmax;
    if (epsz<-1*epszmax)  then epsz:=-1*epszmax;
    zint:=zint+((1-exp(dt/-0.14))*epsz);
    if (zint>epszmax/300)  then zint:=epszmax/300;
    if (zint<-1*epszmax/300)  then zint:=-1*epszmax/300;
    epsx:=sqrt(sqr(voyage[ivoy,1]-xabs)+sqr(voyage[ivoy,2]-yabs));
     if (abs(epsx)<vmaxx*60*1)and ok2 then begin
      vmaxx:=vmaxx/12;
      ok2:=true;
                              end;
    if (epsx>epsxmax)  then epsx:=epsxmax;
    if (epsx<-1*epsxmax)  then epsx:=-1*epsxmax;
    xint:=xint+((1-exp(dt/-0.14))*epsx);
    if (xint>epsxmax/300)  then xint:=epsxmax/300;
    if (xint<-1*epsxmax/300)  then xint:=-1*epsxmax/300;
    motzag:=10500*epsz-10200*zint;
    motzad:=motzag;
    motzdg:=motzag;
    motzdd:=motzag;
    motxag:=21000*epsx-20400*xint;
    motxad:=motxag;
    motxrg:=-1.0*(-1*21000*epsx+20400*xint);
    motxrd:=motxrg;
    epsteta:=+1.0*(rzobj-rz);
    if (epsteta>3.14159265355)  then epsteta:=epsteta-2*3.1415926535;
    if (epsteta<-3.14159265355)  then epsteta:=epsteta+2*3.1415926535;
      if (abs(epsteta)<1/180*3.1415926535)and ok3 then begin
      vmaxteta:=vmaxteta/12;
      ok3:=true;
                              end;
    if (epsteta>epstetamax)  then epsteta:=epstetamax;
    if (epsteta<-1*epstetamax)  then epsteta:=-1*epstetamax;
    tint:=tint+((1-exp(dt/-0.14))*epsteta);
    if (tint>epstetamax/300)  then tint:=epstetamax/300;
    if (tint<-1*epstetamax/300)  then tint:=-1*epstetamax/300;
    dx:=-105000*epsteta+102000*tint;
    if dx>300/6 then dx:=300/6;
    if dx<-300/6 then dx:=-300/6;
    if motzag<0 then  motzag:=0.0;
    if (vz)<-vmax then motzag:=motzag+3000;
    if (vz)<-1.5*vmax then motzag:=motzag+9*3000;
    if motzag>30000 then  motzag:=30000.0;
    if (motzag<30000) then ok:=true;
    if (motzag>30000)and ok then
    begin
      epszmax:=epsz/100;
      ok:=false;
    end;
    if (vz)>vmax then motzag:=motzag-3000;
    if (vz)>1.5*vmax then motzag:=motzag-9*3000;
    if motzag<0 then  motzag:=0.0;
    if motzad<0 then  motzad:=0.0;
    if (vz)<-vmax then motzad:=motzad+3000;
    if (vz)<-1.5*vmax then motzad:=motzad+9*3000;
    if motzad>30000 then  motzad:=30000.0;
    if (vz)>vmax then motzad:=motzad-3000;
    if (vz)>1.5*vmax then motzad:=motzad-9*3000;
    if motzad<0 then  motzad:=0.0;
    if motzdg<0 then  motzdg:=0.0;
    if (vz)<-vmax then motzdg:=motzdg+3000;
    if (vz)<-1.5*vmax then motzdg:=motzdg+9*3000;
    if motzdg>30000 then  motzdg:=30000.0;
    if motzdd<0 then  motzdd:=0.0;
    if (vz)>vmax then motzdg:=motzdg-3000;
    if (vz)>1.5*vmax then motzdg:=motzdg-9*3000;
    if motzdg<0 then  motzdg:=0.0;
    if (vz)<-vmax then motzdd:=motzdd+3000;
    if (vz)<-1.5*vmax then motzdd:=motzdd+9*3000;
    if motzdd>30000 then  motzdd:=30000.0;
    if vz>vmax then motzdd:=motzdd-3000;
    if (vz)>1.5*vmax then motzdd:=motzdd-9*3000;
    if motzdd<0 then  motzdd:=0.0;
    if motxag>30000 then  motxag:=30000.0;
    if {abs}(vx)>vmaxx then motxag:=motxag-3000;
    if {abs}(vx)>2*vmaxx then motxag:=motxag-10*3000;
    if dx>0.0 then motxag:= motxag-dx;
    if (vrz)>vmaxteta then motxag:=motxag-30;
    if (vrz)>2*vmaxteta then motxag:=motxag-300;
    if motxag<0 then  motxag:=0.0;
    if motxad>30000 then  motxad:=30000.0;
    if {abs}(vx)>vmaxx then motxad:=motxad-3000;
    if {abs}(vx)>2*vmaxx then motxad:=motxad-10*3000;
    if dx<0.0 then motxad:= motxad-abs(dx);
    if (vrz)<-vmaxteta then motxad:=motxad-30;
    if (vrz)<-2*vmaxteta then motxad:=motxad-300;
    if motxad<0 then  motxad:=0.0;
    if motxrg>30000 then  motxrg:=30000.0;
    if {abs}(vx){<}>=0*vmaxx then motxrg:=motxrg-3000*10;
    if {abs}(vx){<}>2*vmaxx then motxrg:={motxrg}{-1}+10*3000;
    if dx<0.0 then motxrg:= motxrg-abs(dx);
    if (vrz)<-vmaxteta then motxrg:=motxrg-30;
    if (vrz)<-2*vmaxteta then motxrg:=motxrg-300;
    if motxrg<0 then  motxrg:=0.0;
    if motxrd>30000 then  motxrd:=30000.0;
    if {abs}(vx){<}>=0*vmaxx then motxrd:=motxrd-3000*10;
    if {abs}(vx)>{<}2*vmaxx then motxrd:={motxrd}{-1}+10*3000;
    if dx>0.0 then motxrd:= motxrd-dx;
    if (vrz)>vmaxteta then motxrd:=motxrd-30;
    if (vrz)>2*vmaxteta then motxrd:=motxrd-300;
    if motxrd<0 then  motxrd:=0.0;
     if mas<3279 then begin
       motzag:=0*30000-0*1000-0*30000;
       motzad:=0*30000;
       motzdg:=0*30000-0*1000;
       motzdd:=0*30000-0*30000;
       motxag:=0.0;
       motxad:=0.0;
       motxrg:=0*1000.0;
       motxrd:=0*1000.0;
                     end;
       if (voyage[ivoy,8]=3) then
       begin
         motxag:=0.0;
         motxad:=0.0;
         motxrg:=0*1000.0;
         motxrd:=0*1000.0;
       end;

 {   if ((pt.x>300)and(pt.x<350)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag+30000*0.001/4;
      motzad:=motzad+30000*0.001/4;
      motzdg:=motzdg+30000*0.001/4;
      motzdd:=motzdd+30000*0.001/4;
    end;   }
    canvas.rectangle(860,560,910,610);
   { if ((pt.x>860)and(pt.x<910)and(pt.y>560)and(pt.y<610)) then
    begin
      motxag:=motxag+30000*0.001;
      motxad:=motxad+30000*0.001;
    end;}
    canvas.rectangle(1200,560,1250,610);
  {  if ((pt.x>1200)and(pt.x<1250)and(pt.y>560)and(pt.y<610)) then
    begin
      motxrg:=motxrg+30000*0.001;
      motxrd:=motxrd+30000*0.001;
    end;}
    canvas.brush.color:=clyellow;
{:::::}    canvas.rectangle(400,530,450,580);
   { if ((t>0.1)and(pt.x>400)and(pt.x<450)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/4;
      motzad:=motzad-30000*0.001/4;
      motzdg:=motzdg-30000*0.001/4;
      motzdd:=motzdd-30000*0.001/4;
    end;}
    canvas.rectangle(860,650,910,700);
   { if ((pt.x>860)and(pt.x<910)and(pt.y>650)and(pt.y<700)) then
    begin
      motxag:=motxag-30000*0.001;
      motxad:=motxad-30000*0.001;
    end;}
    canvas.Rectangle(1200,650,1250,700);
   { if ((pt.x>1200)and(pt.x<1250)and(pt.y>650)and(pt.y<700)) then
    begin
      motxrg:=motxrg-30000*0.001;
      motxrd:=motxrd-30000*0.001;
    end; }
{:::}    canvas.brush.color:=clgreen;
    canvas.rectangle(350,530,400,580);
 {   if ((pt.x>350)and(pt.x<400)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/5/4;
      motzad:=motzad-30000*0.001/5/4;
      motzdg:=motzdg-30000*0.001/5/4;
      motzdd:=motzdd-30000*0.001/5/4;
    end; }
    canvas.brush.color:=clblue;
{    canvas.rectangle(80,810,110,840);
    canvas.rectangle(250,810,280,840);
    canvas.rectangle(420,810,450,840);
    canvas.rectangle(590,810,620,840);   }
    canvas.rectangle(760,810,790,840);
   { if ((pt.x>760)and(pt.x<790)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxag+30000*0.0001/5;
    end;
    if motxag>motxad+0.01*30000 then motxag:=motxad+0.01*30000; }
  {  canvas.rectangle(930,810,960,840);
    canvas.rectangle(1100,810,1130,840);
    canvas.rectangle(1270,810,1300,840);  }
    canvas.brush.color:=clyellow;
 {   canvas.rectangle(130,810,160,840);
    canvas.rectangle(300,810,330,840);
    canvas.rectangle(470,810,500,840);
    canvas.rectangle(640,810,670,840);    }
    canvas.rectangle(810,810,840,840);
   { if ((pt.x>810)and(pt.x<840)and(pt.y>810)and(pt.y<840)) then
    begin
      motxad:=motxad+30000*0.0001/5;
    end;
    if motxag<motxad-0.01*30000 then motxad:=motxag+0.01*30000;   }
  {  canvas.rectangle(980,810,1010,840);
    canvas.rectangle(1150,810,1180,840);
    canvas.rectangle(1320,810,1350,840);     }
    canvas.Brush.color:=clgreen;
    canvas.rectangle(790,810,810,840);
   { if ((pt.x>790)and(pt.x<810)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxad;
    end; }

    canvas.Brush.color:=clred;
    canvas.Rectangle(70,round(800-200*(motzag/30000)),170,800);
    canvas.rectangle(240,round(800-200*(motzad/30000)),340,800);
    canvas.rectangle(410,round(800-200*(motzdg/30000)),510,800);
    canvas.rectangle(580,round(800-200*(motzdd/30000)),680,800);
    if abs(motxrg-motxrd)>1 then canvas.Brush.color:=clyellow;
    canvas.rectangle(1090,round(800-200*(motxrg/30000)),1190,800);
    canvas.rectangle(1260,round(800-200*(motxrd/30000)),1360,800);
    canvas.Brush.color:=clred;
    if abs(motxag-motxad)>1 then canvas.Brush.color:=clyellow;
    canvas.rectangle(750,round(800-200*(motxag/30000)),850,800);
    canvas.rectangle(920,round(800-200*(motxad/30000)),1020,800);
    canvas.Brush.Color:=clyellow;
    if (abs(motxag-motxad)>1)and(motxag<1500) then
          canvas.rectangle(750,round(800-200*10*(motxag/30000)),850,800);
    if (abs(motxag-motxad)>1)and(motxad<1500) then
        canvas.rectangle(920,round(800-200*10*(motxad/30000)),1020,800);
   {11&&& if (t>0.1) then begin
    canvas.Rectangle(120,round(700-200/2*500*(motzagmoy/30000)),170,700);
    canvas.rectangle(290,round(700-200/2*500*(motzadmoy/30000)),340,700);
    canvas.rectangle(460,round(700-200/2*500*(motzdgmoy/30000)),510,700);
    canvas.rectangle(630,round(700-200/2*500*(motzddmoy/30000)),680,700);
                    end;     }
    if motxrd<0 then  motxrd:=0.0;
       if dx>0.0 then motxad:= motxad+dx;

{parachute de 100 m2 : 10 m x 10 m}
    canvas.Brush.Color:=clyellow;
    canvas.rectangle(500,100,530,130);
    if ((pt.x>500)and(pt.x<530)and(pt.y>100)and(pt.y<130)) then
    begin
      sz:=100.0;
    end;
    {passage au point suivant du voyage}
    canvas.Brush.Color:=clred;
    canvas.rectangle(400,100,430,130);
    if ((ttop<t) and stop and(pt.x>400)and(pt.x<430)and(pt.y>100)and(pt.y<130)) then
    begin
      ivoy:=ivoy+1;
      stop:=false;
      ttop:=t+5.0;
    end
    else stop:=true;

    varg:=(sqr(vx)+sqr(vy))/((6500000+z)*9.81);
    vx:=vx+(motxag+motxad-motxrg-motxrd-rho*vx*abs(vx)*1.3*sx/2)*dt/mas;
    vy:=vy+(0.0-rho*vy*abs(vy)*2.0*sy/2)*dt/mas;
    vz:=vz+(motzag+motzad+motzdg+motzdd-mas*9.81*(1-varg)*(cos(rx)*cos(ry))-rho*vz*abs(vz)*1.5*sz)*dt/mas;
       writeln('xabs(m) = ',xabs:10:3,'yabs(m) = ',yabs:10:3,'z(m) = ',z:10:3,'lacet(deg) = ',(rz*180/3.1416):10:3);
  {  writeln('vrx(rad) = ',vrx:10:3,'vry(rad) = ',vry:10:3,'vz(m/s) = ',vz:10:3);}
    vrx:=vrx+(motzad*1.0+motzag*(-1)+motzdd*1.0+motzdg*(-1)-mas*9.81*1.0*sin(rx+0*3.14/2))*dt/(mas*0.7*0.7);
    vry:=vry+(motzag*2.0+motzad*2.0-motzdg*2.0-motzdd*2.0
              -motxag*0.0-motxad*0.0+motxrg*0.0+motxrd*0.0-mas*9.81*2.0*sin(ry+0*3.14/2)
              +0.0*2.0*2.0*0.5*4.0*rho*vx*cos(ry)*abs(vx*cos(ry))/2)*dt/(mas*1.5*1.5);
    vrz:=vrz+(motxag*(0.5)-motxad*0.5-motxrg*0.5+motxrd*0.5)*dt/(mas*1.0*1.0);
    gz:=9.81*(1-varg){+sqr(rx)*1.0+sqr(ry)}*1.0+(vz-vzanc)/dt;
    glat:=sqr(rz)*(2.5){+sqr(rx)*1.0+sqr(ry)}*1.0+sqrt(sqr((vx-vxanc)/dt)+sqr((vy-vyanc)/dt));
    vnx:=vx*cos(vrz*dt)-vy*sin(vrz*dt);
    vny:=vx*sin(vrz*dt)+vy*cos(vrz*dt);
    vx:=vnx;
    vy:=vny;
    x:=x+vx*dt;
    y:=y+vy*dt;
    z:=z+vz*dt;
    rx:=rx+vrx*dt;
    ry:=ry+vry*dt;
    rz:=rz+vrz*dt;
    xabs:=xabs+vx*cos(rz)*dt-vy*sin(rz)*dt;
    yabs:=yabs+vx*sin(rz)*dt+vy*cos(rz)*dt;
    if vy>0 then corvit:=(-17/3)/180*3.1415926535;
    if vy<0 then corvit:=(17/3)/180*3.1415926535;
   {versio 8}
    vzanc:=vz;
    vxanc:=vx;
    vyanc:=vy;
    if z<=0.0  then
    begin
      z:=0.0;
      vz:=0.0;
      vx:=0.0;
      vy:=0.0;
      vrz:=0.0;
    end;
    canvas.pen.color:=clblue;
    canvas.brush.color:=clwhite;
    canvas.rectangle(720,100,1020,400);
    canvas.Brush.color:=clblue;
    canvas.ellipse(720,100,1020,400);
    canvas.Brush.color:=clblack;
    t1.x:=720;
    t1.y:=400;
    t2.x:=720+round(0);
    t2.y:=250+round(150*sin(ry)+150*sin(rx));
    t3.x:=1020+round(0);
    t3.y:=250+round(150*sin(ry)-150*sin(rx));
    t4.x:=1020;
    t4.y:=400;
    surfhor[1]:=t1;
    surfhor[2]:=t2;
    surfhor[3]:=t3;
    surfhor[4]:=t4;
    canvas.polygon(surfhor);
    canvas.Brush.color:=clwhite;
    canvas.rectangle(1050,250,1350,350);
    canvas.brush.color:=clblue;
    while rz>2*3.1415626535 do rz:=rz-2*3.1415926535;
    while rz<0*-3.1415926535 do rz:=rz+2*3.1415926535;
        if rz<3.1415926535 then rza:=rz
            else rza:= rz -3.1415926*2;
    canvas.rectangle(1050,250,1200+round(150*rza/3.1415926535),350);
    memo1.lines.clear;
    memo1.lines.add('Hauteur(m) = '+floattostr(z));
    memo2.lines.clear;
    memo2.lines.add('Avancement x(m) = '+floattostr(xabs));
    memo3.lines.clear;
    memo3.lines.add('Avancement y(m) = '+floattostr(yabs));
    memo4.lines.clear;
    memo4.lines.add('vitesse totale (km/h) = '+floattostr(sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6));
    memo5.lines.clear;
    memo5.lines.add('compas (degre)() = '+floattostr(rz*180/3.1415926535));
    memo6.lines.clear;
    memo6.lines.add('vitesse vertiale (km/h) = '+floattostr(vz*3.6));
    memo7.lines.clear;
    if abs(-xabs+voyage[ivoy,1])>1.0 then begin
       rzobj:=arctan((-yabs+voyage[ivoy,2])/(-xabs+voyage[ivoy,1]));
       if ((-xabs+voyage[ivoy,1])<0.0) then rzobj:=rzobj-3.1415926535;
                        end
                   else if abs(-yabs+voyage[ivoy,2])<1.0 then rzobj:= 0.0
                                         else if (-yabs+voyage[ivoy,2]<0) then rzobj:=-3.1415926535/2
                                                          else rzobj:=3.1415926535/2;
    rzobj:=rzobj+corvit;
    while rzobj>2*3.1415626535 do rzobj:=rzobj-2*3.1415926535;
    while rzobj<0*-3.1415926535 do rzobj:=rzobj+2*3.1415926535;
    memo7.lines.add('objectif(degre)() = '+floattostr(rzobj*180/3.1415926535));
    memo8.Lines.Clear;
    memo8.Lines.Add(floattostr(mas)+'kg');
    memo10.Lines.Clear;
    memo10.Lines.Add(floattostr(gz)+'m/s2');
    memo9.Lines.Clear;
{    if abs(glat)<2*9.81 then memo9.Lines.Add('inferieur a 2 g')
      else if abs(glat)<5*9.81 then memo9.Lines.Add('inferieur a 5 g')
                 else }memo9.Lines.Add(floattostr(glat)+'m/s2');
    memo11.Lines.Clear;
    memo11.Lines.Add(inttostr(ivoy));
    canvas.brush.color:=clred;
     if (voyage[ivoy,8]=4.0) then
         if ((abs((rz-rzobj)*180/3.1415926535) < 2.0)or
         ((rz<1/180*3.1415926535)and(rzobj>359/180*3.1415926535))
         or  ((rzobj<1/180*3.1415926535)and(rz>359/180*3.1415926535)))
          then ivoy:=ivoy+1;
    if (voyage[ivoy,8]=1.0) then
         if sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2])+
            sqr(z-voyage[ivoy,3])) < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=2.0) then
         if sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2]))
              < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=3.0) then
         if (sqr(z-voyage[ivoy,3])) < voyage[ivoy,7] then ivoy:=ivoy+1;
   if (voyage[ivoy,8]=5.0) then
         if (sqrt(sqr(xabs-voyage[ivoy,1])+sqr(yabs-voyage[ivoy,2]))
              < voyage[ivoy,7])and(abs(vx)<vmaxx) then ivoy:=ivoy+1;

    if ((vzanc*3.6<-10.0)and(z<0.3))then canvas.Rectangle(1,1,1024,400);
   { memo12.Lines.Add(floattostr(voyage[ivoy,3])+'!'+floattostr(voyage[ivoy,5]));   }
  end;
{  writeln('t(sec) =',t:5:3,'x(m) =',x:10:3,'y(m) = ',y:10:3,'z(m) = ',z:10:3);
                   interface important calculateur,language pascl vers c++
    closefile(mot1);
    closefile(mot2);
    closefile(mot3);
    closefile(mot4);
    closefile(mot5);
    closefile(mot6);
    closefile(mot7);
    closefile(mot8); }
    {end;            }
    until false;
end;

procedure TForm1.Button3Click(Sender: TObject);
{
  voyage : array[1..20,1..8]of double;
     mas,x,y,z,rx,ry,rz,t,xabs,yabs : double;
     ivoy : integer;
     motzag,motzad,motzdg,motzdd,motxag,motxad,motxrg,motxrd : double;
     vx,vy,vz,vrx,vry,vrz : double;
     mot1,mot2,mot3,mot4,mot5,mot6,mot7,mot8 : textfile;
}
var

    motzagmoy,motzadmoy,motzdgmoy,motzddmoy : double;
    motzaganc,motzadanc,motzdganc,motzddanc : double;
    dt,tmax : double;
    vnx,vny : double;
    sx,sy,sz,rho : double;
    pos,pt : tpoint;
    tvrai,t0 : longint;
    t1,t2,t3,t4 : tpoint;
    surfhor : array[1..4] of tpoint;
    p,temp,consomdt,vejgaz,pourairliq,rza,vzanc,rzobj,varg : double;
    dtt,dttt : double;
    ijk,l,nbrdt : integer;
     latitudedeg,latitudemin,latitudesec,longitudedeg,longitudemin,longitudesec : double;
    latitude,longitude,xabsanc,yabsanc,orbite,mas0 : double;
    xabsref,yabsref,tref,dt1,dt2 : double;

begin
xabsref:=0.0;
yabsref:=0.0;
tref:=0.0;
t:=0.0;{bug contr}
dt:=0.02*10;{choix important calculateur}
dtt:=0.0000001;{gene perturbateur mineur}
dttt:=0.00000000;{gene nul visible de petit temps}
  sx:=4.0;
  sy:=10.0;
  sz:=10.0;
     nbrdt:=0;
     assignfile(trajectoire,'trajectoire.txt');
    assignfile(carte,'carte.txt');
    if (test<>1) then
    begin
      rewrite(trajectoire);
    end;
    test:=0;
     latitudedeg:=47.33;
 latitudemin:=0;
 latitudesec:=0;
 longitudedeg:=-121.89;
 longitudemin:=0;
 longitudesec:=0;
  {selon la politique}
  canvas.pen.color:=clwhite;
  canvas.Brush.color:=clyellow;{a changer avec le joystick en blanc}
  canvas.rectangle(0,0,1440,900);
  canvas.pen.color:=clblack;
  canvas.MoveTo(1,550);
  canvas.LineTo(1440,550);
  canvas.brush.color:=clgreen;
  canvas.rectangle(0,550,1440,900);
  {???}  assignfile(mot1,'mot1.txt');
    assignfile(mot2,'mot2.txt');
    assignfile(mot3,'mot3.txt');
    assignfile(mot4,'mot4.txt');
    assignfile(mot5,'mot5.txt');
    assignfile(mot6,'mot6.txt');
    assignfile(mot7,'mot7.txt');
    assignfile(mot8,'mot8.txt');
    assignfile(eng1go,'eng1go.txt');
    assignfile(eng2go,'eng2go.txt');
    assignfile(eng3go,'eng3go.txt');
    assignfile(eng4go,'eng4go.txt');
    assignfile(eng5go,'eng5go.txt');
    assignfile(eng6go,'eng6go.txt');
    assignfile(eng7go,'eng7go.txt');
    assignfile(eng8go,'eng8go.txt');
    vejgaz:=1.0;
    pourairliq:=0.0;
    mascomb:=strtofloat(edit7.Text);
    mascarb:=strtofloat(edit8.Text);
    memo12.Lines.Clear;
    memo12.Lines.Add(floattostr(mascomb)+'kg');
    memo13.Lines.Clear;
    memo13.Lines.Add(floattostr(mascarb)+'kg');
t0:=getcurrenttime;
t0:=round(t0+dtt);{gene+}
tmax:=60.0*30.0*9;
 {essai de regularisation des avertissements}
 motzaganc:=0.0;
 motzadanc:=0.0;
 motzdganc:=0.0;
 motzddanc:=0.0;

while t<tmax do
  begin
t:=t+dt;
consomdt:=(motzag+motzad+motzdg+motzdd+motxag+motxad+motxrg+motxrd)/120000*
               (vejgaz*(1+(1/20)))*dt;
  mascarb:=mascarb-consomdt*1/15.91;
    mascomb:=mascomb-consomdt*(1-1/15.91);
    mas:=mas-consomdt*(1+pourairliq);
    if mas<3663.0 then begin
       motzag:=0*30000-0*1000-0*30000;
       motzad:=0*30000;
       motzdg:=0*30000-0*1000;
       motzdd:=0*30000-0*30000;
       motxag:=0.0;
       motxad:=0.0;
       motxrg:=0*1000.0;
       motxrd:=0*1000.0;
                     end;
       motzagmoy:=motzag-motzaganc;
       motzadmoy:=motzad-motzadanc;
       motzdgmoy:=motzdg-motzdganc;
       motzddmoy:=motzdd-motzddanc;
tvrai:=getcurrenttime;
tvrai:=round(tvrai+dtt);{gene-}
tvrai:=round(tvrai+dttt);{gene nul present}
while ((tvrai-t0)/1000)<t do
    begin
      tvrai:=getcurrenttime;
      for ijk:=1 to 1000000 do l:=ijk;
    end;
    ijk:=l;
    rewrite(mot1);
    writeln(mot1,(motzag/30000):10:3);
    closefile(mot1);
    rewrite(mot2);
    writeln(mot2,(motzad/30000):10:3);
    closefile(mot2);
    rewrite(mot3);
    writeln(mot3,(motzdg/30000):10:3);
    closefile(mot3);
    rewrite(mot4);
    writeln(mot4,(motzdd/30000):10:3);
    closefile(mot4);
    rewrite(mot5);
    writeln(mot5,(motxag/30000):10:3);
    closefile(mot5);
    rewrite(mot6);
    writeln(mot6,(motxad/30000):10:3);
    closefile(mot6);
    rewrite(mot7);
    writeln(mot7,(motxrg/30000):10:3);
    closefile(mot7);
    rewrite(mot8);
    writeln(mot8,(motxrd/30000):10:3);
    closefile(mot8);
   { reset(eng1go);
    readln(eng1go,motzag);
    motzag:=motzag*30000;
    closefile(eng1go);
    reset(eng2go);
    readln(eng2go,motzad);
    motzad:=motzad*30000;
    closefile(eng2go);
    reset(eng3go);
    readln(eng3go,motzdg);
    motzdg:=motzdg*30000;
    closefile(eng3go);
    reset(eng4go);
    readln(eng4go,motzdd);
    motzdd:=motzdd*30000;
    closefile(eng4go);
    reset(eng5go);
    readln(eng5go,motxag);
    motxag:=motxag*30000;
    closefile(eng5go);
    reset(eng6go);
    readln(eng6go,motxad);
    motxad:=motxad*30000;
    closefile(eng6go);
    reset(eng7go);
    readln(eng7go,motxrg);
    motxrg:=motxrg*30000;
    closefile(eng7go);
    reset(eng8go);
    readln(eng8go,motxrd);
    motxrd:=motxrd*30000;
    closefile(eng8go); }

    canvas.Brush.color:=clgreen;
    canvas.rectangle(250,100,290,120);
    if ((pt.x>250)and(pt.x<290)and(pt.y>100)and(pt.y<120)) then
    begin
      tmax:=0.0;
    end;
    if z<10000 then temp:=293.16*(1*((10000-z)/10000)+(z/10000)*(1/sqrt(sqrt(2))))
               else temp:=293.16/sqrt(sqrt(2));
    if z<10000 then p:=1.013e5*(((10000-z)/10000)*1+(z/10000)*0.25)
               else
         if z<20000 then p:=1.013e5*(((20000-z)/10000)*0.25+((z-10000)/10000)*0.1)
                    else p:=0e5;
    rho:=p/(287*temp);
 {   if t>0 then motzag:=30000-0*1000-0*30000;
    if t>0 then motzad:=30000;
    if t>0 then motzdg:=30000-0*1000;
    if t>0 then motzdd:=30000-0*30000;
    if ((t>10) and (t<45)) then motxag:=1.0*30000
             else motxag:=0.0;
    if ((t>10) and (t<45)) then motxad:=1.0*30000
            else motxad:=0.0;
    if t>45 then motxrg:=30000
            else motxrg:=0*1000.0;
    if t>45 then motxrd:=30000
            else motxrd:=0*1000.0;    }
    getcursorpos(pt);
    canvas.brush.color:=clgreen;
    canvas.Rectangle(70,600,170,800);
    canvas.rectangle(240,600,340,800);
    canvas.rectangle(410,600,510,800);
    canvas.rectangle(580,600,680,800);
    canvas.rectangle(750,600,850,800);
    canvas.rectangle(920,600,1020,800);
    canvas.rectangle(1090,600,1190,800);
    canvas.rectangle(1260,600,1360,800);
    canvas.Brush.color:=clblue;
 {:::}   canvas.Rectangle(300,530,350,580);
    motzaganc:=motzag;
    motzadanc:=motzad;
    motzdganc:=motzdg;
    motzddanc:=motzdd;
   if ((pt.x>300)and(pt.x<350)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag+30000*0.001/4*10;
      motzad:=motzad+30000*0.001/4*10;
      motzdg:=motzdg+30000*0.001/4*10;
      motzdd:=motzdd+30000*0.001/4*10;
    end;
    canvas.rectangle(860,560,910,610);
    if ((pt.x>860)and(pt.x<910)and(pt.y>560)and(pt.y<610)) then
    begin
      motxag:=motxag+30000*0.001*10;
      motxad:=motxad+30000*0.001*10;
    end;
    canvas.rectangle(1200,560,1250,610);
    if ((pt.x>1200)and(pt.x<1250)and(pt.y>560)and(pt.y<610)) then
    begin
      motxrg:=motxrg+30000*0.001*10;
      motxrd:=motxrd+30000*0.001*10;
    end;
    canvas.brush.color:=clyellow;
{:::::}    canvas.rectangle(400,530,450,580);
    if ((pt.x>400)and(pt.x<450)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/4*10;
      motzad:=motzad-30000*0.001/4*10;
      motzdg:=motzdg-30000*0.001/4*10;
      motzdd:=motzdd-30000*0.001/4*10;
    end;
    canvas.rectangle(860,650,910,700);
    if ((pt.x>860)and(pt.x<910)and(pt.y>650)and(pt.y<700)) then
    begin
      motxag:=motxag-30000*0.001*10;
      motxad:=motxad-30000*0.001*10;
    end;
    canvas.Rectangle(1200,650,1250,700);
    if ((pt.x>1200)and(pt.x<1250)and(pt.y>650)and(pt.y<700)) then
    begin
      motxrg:=motxrg-30000*0.001*10;
      motxrd:=motxrd-30000*0.001*10;
    end;
{:::}    canvas.brush.color:=clgreen;
    canvas.rectangle(350,530,400,580);
    if ((pt.x>350)and(pt.x<400)and(pt.y>530)and(pt.y<580)) then
    begin
      motzag:=motzag-30000*0.001/5/4*10;
      motzad:=motzad-30000*0.001/5/4*10;
      motzdg:=motzdg-30000*0.001/5/4*10;
      motzdd:=motzdd-30000*0.001/5/4*10;
    end;
    canvas.brush.color:=clblue;
    canvas.rectangle(80,810,110,840);
    canvas.rectangle(250,810,280,840);
    canvas.rectangle(420,810,450,840);
    canvas.rectangle(590,810,620,840);
    canvas.rectangle(760,810,790,840);
    if ((pt.x>760)and(pt.x<790)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxag+30000*0.0001/5*10;
    end;
    if motxag>motxad+0.01*30000 then motxag:=motxad+0.01*30000;
    canvas.rectangle(930,810,960,840);
    canvas.rectangle(1100,810,1130,840);
    canvas.rectangle(1270,810,1300,840);
    canvas.brush.color:=clyellow;
    canvas.rectangle(130,810,160,840);
    canvas.rectangle(300,810,330,840);
    canvas.rectangle(470,810,500,840);
    canvas.rectangle(640,810,670,840);
    canvas.rectangle(810,810,840,840);
    if ((pt.x>810)and(pt.x<840)and(pt.y>810)and(pt.y<840)) then
    begin
      motxad:=motxad+30000*0.0001/5*10;
    end;
    if motxag<motxad-0.01*30000 then motxad:=motxag+0.01*30000;
    canvas.rectangle(980,810,1010,840);
    canvas.rectangle(1150,810,1180,840);
    canvas.rectangle(1320,810,1350,840);
    canvas.Brush.color:=clgreen;
    canvas.rectangle(790,810,810,840);
    if ((pt.x>790)and(pt.x<810)and(pt.y>810)and(pt.y<840)) then
    begin
      motxag:=motxad;
    end;

    canvas.Brush.color:=clred;
    canvas.Rectangle(70,round(800-200*(motzag/30000)),170,800);
    canvas.rectangle(240,round(800-200*(motzad/30000)),340,800);
    canvas.rectangle(410,round(800-200*(motzdg/30000)),510,800);
    canvas.rectangle(580,round(800-200*(motzdd/30000)),680,800);
    canvas.rectangle(1090,round(800-200*(motxrg/30000)),1190,800);
    canvas.rectangle(1260,round(800-200*(motxrd/30000)),1360,800);
    if abs(motxag-motxad)>1 then canvas.Brush.color:=clyellow;
    canvas.rectangle(750,round(800-200*(motxag/30000)),850,800);
    canvas.rectangle(920,round(800-200*(motxad/30000)),1020,800);
    canvas.Brush.Color:=clyellow;
    if (abs(motxag-motxad)>1)and(motxag<1500) then
          canvas.rectangle(750,round(800-200*10*(motxag/30000)),850,800);
    if (abs(motxag-motxad)>1)and(motxad<1500) then
        canvas.rectangle(920,round(800-200*10*(motxad/30000)),1020,800);
if (t>0.1) then begin
if (200/2*500*(motzagmoy/30000)<150) then canvas.Rectangle(120,round(700-200/2*500*(motzagmoy/30000)),170,700);
if (200/2*500*(motzadmoy/30000)<150) then canvas.rectangle(290,round(700-200/2*500*(motzadmoy/30000)),340,700);
if (200/2*500*(motzdgmoy/30000)<150) then canvas.rectangle(460,round(700-200/2*500*(motzdgmoy/30000)),510,700);
if (200/2*500*(motzddmoy/30000)<150) then canvas.rectangle(630,round(700-200/2*500*(motzddmoy/30000)),680,700);
                    end;
    if motzag>30000 then  motzag:=30000.0;
    if motzag<0 then  motzag:=0.0;
    if motzad>30000 then  motzad:=30000.0;
    if motzad<0 then  motzad:=0.0;
    if motzdg>30000 then  motzdg:=30000.0;
    if motzdg<0 then  motzdg:=0.0;
    if motzdd>30000 then  motzdd:=30000.0;
    if motzdd<0 then  motzdd:=0.0;
    if motxag>30000 then  motxag:=30000.0;
    if motxag<0 then  motxag:=0.0;
    if motxad>30000 then  motxad:=30000.0;
    if motxad<0 then  motxad:=0.0;
    if motxrg>30000 then  motxrg:=30000.0;
    if motxrg<0 then  motxrg:=0.0;
    if motxrd>30000 then  motxrd:=30000.0;
    if motxrd<0 then  motxrd:=0.0;
    memo12.Lines.Clear;
    memo12.Lines.Add(floattostr(mascomb)+'kg');
    memo13.Lines.Clear;
    memo13.Lines.Add(floattostr(mascarb)+'kg');
     nbrdt:=nbrdt+1;
    if ((nbrdt=300) and (test<>1))then
    begin
      latitude:=latitudedeg+latitudemin/60+latitudesec/3600;
      longitude:=longitudedeg+longitudemin/60+longitudesec/3600;
      latitude:=latitude+(xabs-xabsanc)/6378000.0*180/3.1415926535;
      longitude:=longitude+(yabs-yabsanc)/6378000.0*180/3.1415926535/cos(latitude*3.1415926535/180);
      rewrite(carte);
      writeln(carte,latitude,' ',longitude,' ',sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6);
      closefile(carte);
      latitudedeg:=int(latitude);
      latitudemin:=int((latitude-latitudedeg)*60);
      latitudesec:=int((latitude-latitudedeg-latitudemin/60)*3600);
      longitudedeg:=int(longitude);
      longitudemin:=int((longitude-longitudedeg)*60);
      longitudesec:=int((longitude-longitudedeg-longitudemin/60)*3600);
      writeln(trajectoire,'lat(deg,min,sec) : ',
      latitudedeg:3:3,',',latitudemin:2:2,',',latitudesec:7:3,
      'long(deg,min,sec) :',
      longitudedeg:3:3,',',longitudemin:2:2,',',longitudesec:7:3,
      ' z(m)= ',z);
      writeln(trajectoire,'v tot(km/h) = ',sqrt(sqr(vx)+sqr(vy)+sqr(vz))*3.6,
                          'vz (km/h) = ',vz*3.6,' t(sec)= ',t);
{      writeln(trajectoire,'F vert z(N) = ',rho*sqr(vz)/2*sz*1.3,
                          'F avanc (N) = ',rho*sqr(vx)/2*sx*1.5);  }
      nbrdt:=0;
      xabsanc:=xabs;
      yabsanc:=yabs;
    end;
    memo14.Lines.Clear;
    memo14.Lines.Add(floattostr(sqrt(sqr(xabsref-xabs)+sqr(yabsref-yabs))/1000)+' km');
    memo15.Lines.Clear;
    if (yabs-yabsref>1e-8) then
        memo15.Lines.Add(floattostr(90.0-180/3.1415926535*arctan((xabs-xabsref)/(yabs-yabsref)))+' degres');
    if (yabs-yabsref<-1e-8) then
        memo15.Lines.Add(floattostr(270.0-180/3.1415926535*arctan((xabs-xabsref)/(yabs-yabsref)))+' degres');
    if (abs(yabs-yabsref)<1.2e-8) then
       if ((xabs-xabsref)>0) then
         begin
           memo15.Lines.Clear;
           memo15.Lines.Add(floattostr(0)+' degres')
         end
                              else
         begin
           memo15.Lines.Clear;
           memo15.Lines.Add(floattostr(180)+' degres');
         end;
    memo16.Lines.Clear;
    memo16.Lines.Clear;
    dt1:=t-tref;
    dt2:=dt1;
    dt1:=int(dt1/60);
    dt2:=dt2-60*dt1;
    memo16.Lines.Add(floattostr(dt1)+'min '+floattostr(dt2)+'sec ');
    varg:=(sqr(vx)+sqr(vy))/((6500000+z)*9.81);
vx:=vx+(motxag+motxad-motxrg-motxrd-rho*vx*abs(vx)*1.3*sx/2)*dt/mas;
vy:=vy+(0.0-rho*vy*abs(vy)*2.0*sy/2)*dt/mas;
vz:=vz+(motzag+motzad+motzdg+motzdd-mas*9.81*(1-varg)*(cos(rx)*cos(ry))-rho*vz*abs(vz)*1.5*sz)*dt/mas;
{    writeln('vrx(rad) = ',vrx:10:3,'vry(rad) = ',vry:10:3,'vz(m/s) = ',vz:10:3)}
vrx:=vrx+(motzad*1.0+motzag*(-1)+motzdd*1.0+motzdg*(-1)-mas*9.81*1.0*sin(rx+0*3.14/2))*dt/(mas*0.7*0.7);
vry:=vry+(motzag*2.0+motzad*2.0-motzdg*2.0-motzdd*2.0
              -motxag*0.0-motxad*0.0+motxrg*0.0+motxrd*0.0-mas*9.81*1.0*sin(ry+0*3.14/2)
              +0.0*2.0*2.0*0.5*4.0*rho*vx*cos(ry)*abs(vx*cos(ry))/2)*dt/(mas*1.5*1.5);
vrz:=vrz+(motxag*(0.5)-motxad*0.5-motxrg*0.5+motxrd*0.5)*dt/(mas*1.0*1.0);
vnx:=vx*cos(vrz*dt)+vy*sin(vrz*dt);
vny:=-vx*sin(vrz*dt)+vy*cos(vrz*dt);
    vx:=vnx;
    vy:=vny;
x:=x+vx*dt;
y:=y+vy*dt;
z:=z+vz*dt;
rx:=rx+vrx*dt;
ry:=ry+vry*dt;
rz:=rz+vrz*dt;
xabs:=xabs+vx*cos(rz)*dt-vy*sin(rz)*dt;
yabs:=yabs+vx*sin(rz)*dt+vy*cos(rz)*dt;
 {versio 8}
    vzanc:=vz;
    if z<=0.0  then
    begin
      z:=0.0;
      vz:=0.0;
      vx:=0.0;
      vy:=0.0;
      vrz:=0.0;
    end;
    canvas.pen.color:=clblue;
    canvas.brush.color:=clwhite;
    canvas.rectangle(720,100,1020,400);
    canvas.Brush.color:=clblue;
    canvas.ellipse(720,100,1020,400);
    canvas.Brush.color:=clblack;
    t1.x:=720;
    t1.y:=400;
    t2.x:=720+round(0);
    t2.y:=250+round(150*sin(ry)+150*sin(rx));
    t3.x:=1020+round(0);
    t3.y:=250+round(150*sin(ry)-150*sin(rx));
    t4.x:=1020;
    t4.y:=400;
    surfhor[1]:=t1;
    surfhor[2]:=t2;
    surfhor[3]:=t3;
    surfhor[4]:=t4;
    canvas.polygon(surfhor);
    canvas.Brush.color:=clwhite;
    canvas.rectangle(1050,250,1350,350);
    canvas.brush.color:=clblue;
    while rz>3.1415626535 do rz:=rz-2*3.1415926535;
    while rz<-3.1415926535 do rz:=rz+2*3.1415926535;
    canvas.rectangle(1050,250,1200+round(150*rz/3.1415926535),350);
    memo1.lines.clear;
    memo1.lines.add('Hauteur(m) = '+floattostr(z));
    memo2.lines.clear;
    memo2.lines.add('Avancement Nord(m) = '+floattostr(xabs));
    memo3.lines.clear;
    memo3.lines.add('Avancement Est(m) = '+floattostr(yabs));
    memo4.lines.clear;
    memo4.lines.add('vitesse locale x (km/h) = '+floattostr(vx*3.6));
    memo17.lines.clear;
    memo17.lines.add('vitesse locale y (km/h) = '+floattostr(vy*3.6));
    memo5.lines.clear;
    if rz>0 then rza:=rz
            else rza:= rz +3.1415926*2;
    memo5.lines.add('compas (degre)() = '+floattostr(rza*180/3.1415926535));
    memo6.lines.clear;
    memo6.lines.add('vitesse vertiale (km/h) = '+floattostr(vz*3.6));
    memo7.lines.clear;
    if abs(xabs)>1.0 then begin
       rzobj:=arctan(yabs/xabs);
       if (xabs>0.0) then rzobj:=rzobj-3.1415926535;
                        end
                   else if abs(yabs)<1.0 then rzobj:= 0.0
                                         else if (yabs>0) then rzobj:=-3.1415926535/2
                                                          else rzobj:=3.1415926535/2;
    while rzobj>2*3.1415626535 do rzobj:=rzobj-2*3.1415926535;
    while rzobj<0.0 do rzobj:=rzobj+2*3.1415926535;
    memo7.lines.add('objectif(degre)() = '+floattostr(rzobj*180/3.1415926535));
    memo8.Lines.Clear;
    memo8.Lines.Add(floattostr(mas));
    canvas.brush.color:=clred;
    if ((vzanc*3.6<-10.0)and(z<0.3))then canvas.Rectangle(1,1,1024,400);
  end;
{writeln('t(sec) =',t:5:3,'x(m) =',x:10:3,'y(m) = ',y:10:3,'z(m) = ',z:10:3);   }
end;

procedure TForm1.Button4Click(Sender: TObject);
var {q : tfield;}
  table : textfile;
    j : integer;
begin
    assignfile(table,'cheminspatial.txt');
    reset(table);
   for j:= 1 to 8{8}{(dbgrid1.fieldcount-1)} do
  begin
     { q:=dbgrid1.fields[0];
      voyage[j,1]:=strtoint(q.AsString);
      q:=dbgrid1.fields[1];
      voyage[j,2]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[2];
      voyage[j,3]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[3];
      voyage[j,4]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[4];
      voyage[j,5]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[5];
      voyage[j,6]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[6];
      voyage[j,7]:={q.Asinteger;}{strtoint(q.AsString);
      q:=dbgrid1.fields[7];
      voyage[j,8]:={q.Asinteger;}{strtoint(q.AsString);
      table1.MoveBy(1);    }
      readln(table,voyage[j,1] ,voyage[j,2],voyage[j,3],voyage[j,4]
      ,voyage[j,5],voyage[j,6],voyage[j,7],voyage[j,8]);
  end;
  closefile(table);
{  table1.Close; }

end;

procedure TForm1.Button5Click(Sender: TObject);
var
  table,table1 : textfile;
    j : integer;
    ch1 : char;
begin
    assignfile(table,'Table1.txt');
    reset(table);
    assignfile(table1,'cheminspatial.txt');
    rewrite(table1);
    read(table,ch1);
    write(table1,ch1);
    while not eof(table) do
    begin read(table,ch1);
          if (ch1=',') then ch1:='.';
          write(table1,ch1);
    end;
    closefile(table);
    closefile(table1);
  {  closefile(trajectoire);}
end;

end.
